"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.monitor = (target, accessed) => {
    const monitored = {};
    const spy = (target, prop) => {
        accessed.add(prop);
        return target[prop];
    };
    for (const prop in target) {
        if (!target.hasOwnProperty(prop)) {
            continue;
        }
        exports.define(monitored, prop, {
            enumerable: true,
            get: () => spy(target, prop),
        });
    }
    return monitored;
};
exports.define = (target, prop, attributes) => (Object.defineProperty(target, prop, attributes));
exports.sanitize = (keys, props) => {
    const remove = (_a, key) => {
        var _b = key, value = _a[_b], rest = __rest(_a, [typeof _b === "symbol" ? _b : _b + ""]);
        return rest;
    };
    return [...keys].reduce(remove, props);
};
